\version "2.14.2"
#(ly:set-option 'point-and-click #f)
\include "deutsch.ly"


%%%%%%%%%%  This provides joint rests
%%%%%%%%%%  for the voices of the right hand in the realisation
%%%%%%%%%%  of the figured bass
#(define (rest-score r)
  (let ((score 0)
        (yoff (ly:grob-property-data r 'Y-offset))
        (sp (ly:grob-property-data r 'staff-position)))
    (if (number? yoff)
        (set! score (+ score 2))
        (if (eq? yoff 'calculation-in-progress)
            (set! score (- score 3))))
    (and (number? sp)
         (<= 0 2 sp)
         (set! score (+ score 2))
         (set! score (- score (abs (- 1 sp)))))
    score))

#(define (merge-rests-on-positioning grob)
  (let* ((can-merge #f)
         (elts (ly:grob-object grob 'elements))
         (num-elts (and (ly:grob-array? elts)
                        (ly:grob-array-length elts)))
         (two-voice? (= num-elts 2)))
    (if two-voice?
        (let* ((v1-grob (ly:grob-array-ref elts 0))
               (v2-grob (ly:grob-array-ref elts 1))
               (v1-rest (ly:grob-object v1-grob 'rest))
               (v2-rest (ly:grob-object v2-grob 'rest)))
          (and
           (ly:grob? v1-rest)
           (ly:grob? v2-rest)
           (let* ((v1-duration-log (ly:grob-property v1-rest 'duration-log))
                  (v2-duration-log (ly:grob-property v2-rest 'duration-log))
                  (v1-dot (ly:grob-object v1-rest 'dot))
                  (v2-dot (ly:grob-object v2-rest 'dot))
                  (v1-dot-count (and (ly:grob? v1-dot)
                                     (ly:grob-property v1-dot 'dot-count -1)))
                  (v2-dot-count (and (ly:grob? v2-dot)
                                     (ly:grob-property v2-dot 'dot-count -1))))
             (set! can-merge
                   (and
                    (number? v1-duration-log)
                    (number? v2-duration-log)
                    (= v1-duration-log v2-duration-log)
                    (eq? v1-dot-count v2-dot-count)))
             (if can-merge
                 ;; keep the rest that looks best:
                 (let* ((keep-v1? (>= (rest-score v1-rest)
                                      (rest-score v2-rest)))
                        (rest-to-keep (if keep-v1? v1-rest v2-rest))
                        (dot-to-kill (if keep-v1? v2-dot v1-dot)))
                   ;; uncomment if you're curious of which rest was chosen:
                   ;;(ly:grob-set-property! v1-rest 'color green)
                   ;;(ly:grob-set-property! v2-rest 'color blue)
                   (ly:grob-suicide! (if keep-v1? v2-rest v1-rest))
                   (if (ly:grob? dot-to-kill)
                       (ly:grob-suicide! dot-to-kill))
                   (ly:grob-set-property! rest-to-keep 'direction 0)
                   (ly:rest::y-offset-callback rest-to-keep)))))))
    (if can-merge
        #t
        (ly:rest-collision::calc-positioning-done grob))))



%%%%%%%%%%%%%%       MAKROS        %%%%%%%%%%%%%%%%%%%%%%%%%%%%%
tr = ^\markup { \bold {+}}
st = ^\staccatissimo

%  Unterbalken geändert: statt 3 * 2 16-tel nun 2 * 3 16-tel
qbeam = {
  \set subdivideBeams = ##t
  \set Staff.beatLength = #(ly:make-moment 3 16)
  \set Staff.beatLength = #(ly:make-moment 3 8)
}
% Unterbalken gemäß Standard
nbeam = {
  \set Staff.beatLength = #(ly:make-moment 1 8)
  \set subdivideBeams = ##f
}
% Linien im Generalbass ein und ausschalten
lj = \set useBassFigureExtenders = ##t
ln = \set useBassFigureExtenders = ##f


% bei Verzierungen: Hälse kürzen, Hals nach unten, kleine Noten
sk =  { \once \override Stem #'length-fraction = #0.6 \once \override Stem #'direction = #DOWN \once \set fontSize = #-3   }
ska = { \once \override Stem #'length-fraction = #0.7 \once \override Stem #'direction = #DOWN \once \set fontSize = #-3   }
sku = { \once \override Stem #'length-fraction = #0.7 \once \override Stem #'direction = #UP \once \set fontSize = #-3   }
skn = { \once \override Stem #'length-fraction = #1 \once \override Stem #'direction = #DOWN \once \set fontSize = #-3   }
sn =     \override Stem #'length-fraction = #1  %normale Länge

% Nötig für weiße Notenköpfe
dua = \override NoteHead #'duration-log = #1
duo = \override NoteHead #'duration-log = #0

% plus = { \markup \halign #-1.7  \center-column { \musicglyph #"scripts.stopped"  } }

%%%%%%%%%%%%%       ENDE MAKRO     %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


\header {
  title = \markup
    {"Sonate II" \override #'(font-size . 3)  \raise #2 "e"  }
  subtitle = \markup
    { "aus / du /from \"Sonates en trio\" op. 3 (Paris 1712)"}
  subsubtitle = \markup
    {"für 2 Blockflöten und B.c. / pour 2 flûtes à bec et b.c / for 2 recorders and b.c"}
  instrument =  \markup
    { \tiny "Blocklöten / Flûtes à bec / Flutes" }
  composer = \markup  \override #'(baseline-skip . 2)
  {\center-column     {"\n" "\n" "Jacquez Martin Hotteterre"
      \tiny "(1674 - 1763)"
      %   \tiny "Figured bass arrangement and"
      \tiny "Published by Franz-Rudolf Kuhnen" }
  }
  copyright =
  \markup  {
    \teeny "Published under Creative Commons Attribution-ShareAlike 3.0 (http://creativecommons.org)
    -
    http://noten.kuhnen-musik.de (Rev.: 01-20120922)"
  }
}



\paper {
  myStaffSize = #18
  #(define fonts
    (make-pango-font-tree "Times New Roman"
                          "Arial"
                          "Luxi Mono"
                           (/ myStaffSize 18)))
  line-width = 18\cm
  ragged-last-bottom = ##f
}

#(set-default-paper-size "a4")
#(set-global-staff-size 20)



%=================    1, Movement:  Prelude   ===========================

\score { \transpose d f
<<
   \override Score.BarNumber  #'font-shape = #'italic
   \override Score.BarNumber  #'font-series = #'bold
   \override Score.RehearsalMark  #'break-visibility = #begin-of-line-invisible

  \new ChoirStaff <<
    \new Staff
    \include "stimmen/2_1_01_fl.ly"

    \new Staff
    \include "stimmen/2_1_02_fl.ly"
  >>

  \new GrandStaff <<
   %  \new Staff
%     \include "stimmen/2_1_03_rh.ly"
% 
%    
%     \new Staff
%     \include "stimmen/2_1_04_lh.ly"
%     \include "stimmen/2_1_05_figures.ly"
  >>
>>

\layout { indent = 0  
          \context {
            \Staff
            %  \override TimeSignature #'style = #'single-digit
          }
          \context {
            \FiguredBass
            \override BassFigure #'font-size = #-1
          }
}

\header {
  piece=   \markup { \left-column {
      \override #'(font-size . 3)
      \italic "Prelude"
      \small \italic "Gravement"
    }
  }
 }
}

\pageTurn



%=================    2, Movement:  Courante   ===========================

\score { \transpose d f
<<
   \override Score.BarNumber  #'font-shape = #'italic
   \override Score.BarNumber  #'font-series = #'bold
   \override Score.RehearsalMark  #'break-visibility = #begin-of-line-invisible

  \new ChoirStaff <<
    \new Staff
    \include "stimmen/2_2_01_fl.ly"

    \new Staff
    \include "stimmen/2_2_02_fl.ly"
  >>

  \new GrandStaff <<
   %  \new Staff
%     \include "stimmen/2_2_03_rh.ly"
% 
%    
   %  \new Staff
%     \include "stimmen/2_2_04_lh.ly"
%     \include "stimmen/2_2_05_figures.ly"
  >>
>>

\layout { indent = 0  
          \context {
            \Staff
            \override TimeSignature #'style = #'single-digit
          }
          \context {
            \FiguredBass
            \override BassFigure #'font-size = #-1
          }
}

\header {
  piece=   \markup { \left-column {
      \override #'(font-size . 3)
      \italic "Courante"
      \small \italic "Legerement"
    }
  }
 }
}

\pageTurn



%=================    3, Movement:  Grave   ===========================

\score { \transpose d f
<<
   \override Score.BarNumber  #'font-shape = #'italic
   \override Score.BarNumber  #'font-series = #'bold
   \override Score.RehearsalMark  #'break-visibility = #begin-of-line-invisible

  \new ChoirStaff <<
    \new Staff
    \include "stimmen/2_3_01_fl.ly"

    \new Staff
    \include "stimmen/2_3_02_fl.ly"
  >>

  \new GrandStaff <<
   %  \new Staff
%     \include "stimmen/2_3_03_rh.ly"
% 
%    
  % \new Staff
%     \include "stimmen/2_3_04_lh.ly"
%     \include "stimmen/2_3_05_figures.ly"
  >>
>>

\layout { indent = 0  
          \context {
            \Staff
            % \override TimeSignature #'style = #'single-digit
          }
          \context {
            \FiguredBass
            \override BassFigure #'font-size = #-1
          }
}

\header {
  piece=   \markup { \left-column {
      \override #'(font-size . 3)
      \italic "Grave"
      % \small \italic "Legerement"
    }
  }
 }
}

% \pageTurn



%=================    4, Movement:  Gigue   ===========================

\score { \transpose d f
<<
   \override Score.BarNumber  #'font-shape = #'italic
   \override Score.BarNumber  #'font-series = #'bold
   \override Score.RehearsalMark  #'break-visibility = #begin-of-line-invisible

  \new ChoirStaff <<
    \new Staff
    \include "stimmen/2_4_01_fl.ly"
 
    \new Staff
    \include "stimmen/2_4_02_fl.ly"
  >>

  \new GrandStaff <<
   %  \new Staff
%     \include "stimmen/2_4_03_rh.ly"
% 
%    
  % \new Staff
%     \include "stimmen/2_4_04_lh.ly"
%     \include "stimmen/2_4_05_figures.ly"
  >>
>>

\layout { indent = 0  
          \context {
            \Staff
            % \override TimeSignature #'style = #'single-digit
          }
          \context {
            \FiguredBass
            \override BassFigure #'font-size = #-1
          }
}

\header {
  piece=   \markup { \left-column {
      \override #'(font-size . 3)
      \italic "Gigue"
      \small \italic "Vivement"
    }
  }
 }
}


